obj/BulletHit
	icon='effects.dmi'
	icon_state="BulletHit"
	layer=FLOAT_LAYER
	New(var/IS,var/mob/NM,var/YN)
		//del src;return
		src.icon_state=IS
		src.pixel_x+=rand(-3,3);src.pixel_y+=rand(-3,3)
		NM.overlays+=src
		spawn(5)
			if(YN=="Yes")
				if(NM)	NM.overlays-=src
			del src
		return ..()

var/VirusIcon=new/obj/Supplemental/VirusIcon
obj/Supplemental
	VirusIcon
		icon='Effects.dmi'
		icon_state="Infection"

var/AntiVirusIcon=new/obj/Supplemental/AntiVirusIcon
obj/Supplemental
	AntiVirusIcon
		icon='Effects.dmi'
		icon_state="AntiVirus"

mob/proc/GenericFire(/**/)
	if(src.Reloading || !src.CanAct || !src.Weapon)	return
	if(src.Firing || src.Reloading || !src.Weapon)	return
	if(src.Weapon && src.Weapon.Ammo<=0)	{src<<sound('reload1.ogg');src.Reload();return}
	if("[src.Weapon] Fire" in icon_states(src.icon))	flick("[src.Weapon] Fire",src)
	else	flick("Null Fire",src)
	var/Vol=100;if(!src.key)	Vol=50
	view(WorldView,src)<<sound(src.Weapon.firesound,volume=Vol)
	src.Weapon.Ammo-=1;src.AmmoHUD()
	src.TotalShots+=1
	src.Firing=1;src.StopFire()
	spawn(-1)	if(src && src.Weapon && src.Weapon.Ammo<=0)	src.Reload()
	return 1

mob/proc/StopFire()
	spawn(src.Weapon.FireRate)	src.Firing=0

mob/proc/ShootZombie(var/mob/Zombie/Z,var/mob/Killer,var/ShotHeight=0,var/CountShot=1)
	var/NewDir=get_dir(src,Z)
	if(src.dir!=NewDir)	src.SetDir(NewDir)
	if(!Z.Hunting)	{Z.MobTarget=src;Z.Hunt()}
	if(!src.Weapon)	return
	if(src.Weapon.AmmoTypeName=="Rocket Ammo")
		src.GiveWeaponExp(1)
		src.FireRocket(Z);return
	var/ProfBoost=0;var/ShowDamage=1
	if(src.Weapon.ProfBoostSkill in src.Skills)	ProfBoost=src.Weapon.Proficiency
	var/Damage=src.Weapon.FirePower+rand(-round(src.Weapon.FirePower/10,1),round(src.Weapon.FirePower/10,1))
	if(src.FireAmmo)	Z.SetOnFireBy(src)
	if(rand(1,100)<=src.Weapon.Proficiency+ProfBoost || ShotHeight>=15)
		Damage*=2	//Got a HeadShot
		if(ShotHeight>=15)	Damage=Z.HP
		if(Z.HP-Damage<=0)
			Z.overlays-=Z.HeadIcon;Z.HeadIcon=null
		if(CountShot)	src.HeadShots+=1
		usr.GiveVal(1)	//disable this line if using the next
		//Killer.HeadShots+=1;Killer.GiveVal(1)	//gives val to players for AI controlled headshots
		ShowDamage=0;if(src.client)	DamageShow(Z,Damage,'CritDamageNums.dmi')
	new/obj/BulletHit(src.Weapon.AmmoTypeName,Z,"No")
	Z.HP-=Damage;if(ShowDamage && src.client)	DamageShow(Z,Damage)
	if(Z.HP<=0)
		src.GiveWeaponExp(1)
		src.Killed(Z)
		//Killer.Killed(Z)	//counter AI kills for the controlling player

mob/proc/GiveWeaponExp(var/Exp2Give=1)
	src.Weapon.Exp+=Exp2Give
	if(src.Weapon.Exp>=src.Weapon.Level*100)
		src.Weapon.Exp=0;src.Weapon.Level+=1
		if(src.client)
			world<<"\icon[src.Weapon] <b><font color=white>[src]'s [src.Weapon] has Reached Level [src.Weapon.Level]!"

mob/verb/Fire()
	set hidden=1
	var/mob/ControlledBy=usr
	if(usr.RcD)	usr=usr.RcD
	if(usr.Owner)	ControlledBy=usr.Owner
	if(usr.Weapon)
		if(!usr.GenericFire())	return
		//enable the next line if using the ones further down
		//if(usr!=ControlledBy)	ControlledBy.TotalShots+=1	//Counts drone/AI shots for the player
		for(var/obj/TurfType/Window/W in get_step(usr,usr.dir))
			if(W.MaxHP<500 && W.HP>0)	{W.HP=0;W.BreakWindow();return}
		var/counter=0
		for(var/mob/Zombie/Z in oview(usr.Weapon.Range,usr))
			if(counter==0)	usr.ShotsHit+=1	//disable this if using the next line
			//if(counter==0)	ControlledBy.ShotsHit+=1	//Counts hits as the player's instead of the RcDs/AIs
			if(counter==0)	usr.ShootZombie(Z,ControlledBy)
			else	usr.ShootZombie(Z,ControlledBy,CountShot=0)
			counter+=1
			if(!usr || !usr.Weapon)	return
			if(counter>=usr.Weapon.Radial)	return
		if(!counter)	view(WorldView)<<sound(pick('ric1.ogg','ric2.ogg','ric3.ogg','ric4.ogg','ric5.ogg'))

mob/verb/Reload(/**/)
	set hidden=1
	if(src.Reloading || !src.CanAct)	return
	if(src.Weapon)
		if(src.Weapon.Ammo>=src.Weapon.MaxAmmo)	return
		var/obj/Guns/ReloadWeapon=src.Weapon
		if(ReloadWeapon.AmmoType.Ammo<=0)	return
		src.FireAmmo=0
		src.Reloading=1
		flick("!",src.ChatBubble)
		if(rand(1,2)==1)	src.PlayVoice(view(WorldView),"Reloading")
		else	src.PlayVoice(view(WorldView),"Cover Me")
		view(WorldView)<<sound('w_clipout.ogg')
		sleep(ReloadWeapon.ReloadTime)
		if(src)
			src.Reloading=0
			if(src.Weapon==ReloadWeapon)
				ReloadWeapon.AmmoType.Ammo+=ReloadWeapon.Ammo
				if(ReloadWeapon.AmmoType.Ammo>ReloadWeapon.MaxAmmo)
					ReloadWeapon.Ammo=ReloadWeapon.MaxAmmo
					ReloadWeapon.AmmoType.Ammo-=ReloadWeapon.Ammo
				else
					ReloadWeapon.Ammo=ReloadWeapon.AmmoType.Ammo
					ReloadWeapon.AmmoType.Ammo=0
					//view(WorldView)<<"<b>[src.name]: 'I'm down to my Last Clip of Ammo!'"
					flick("!",src.ChatBubble);src.PlayVoice(view(WorldView),"Need Backup")
				if("Infinite Ammo" in src.Skills)	ReloadWeapon.AmmoType.Ammo=ReloadWeapon.AmmoType.MaxAmmo
				view(WorldView)<<sound('w_clipin.ogg')
				src.ReloadHUD()

mob/verb/Knife(/**/)
	set hidden=1
	if(src.Firing || src.Reloading) return
	if(!src.Downed && !src.CanAct)	return
	src.Firing=1
	if(src.Class=="Ninja")
		spawn(20)	if(src)	src.Firing=0
	else
		spawn(5)	if(src)	src.Firing=0
	flick("Knife",src);view(WorldView)<<sound('swoosh.ogg')
	if(src.Downed)	flick("DownedKnife",src)
	for(var/obj/TurfType/Window/W in get_step(src,src.dir))
		if(W.HP>0)	{W.HP-=5;W.BreakWindow();return}
	for(var/mob/Zombie/Z in view(1,src))
		var/NewDir=get_dir(src,Z)
		if(src.dir!=NewDir)	src.SetDir(NewDir)
		if(src.Class=="Ninja")	Z.HP=0
		var/Damage=rand(4,6)
		Z.HP-=Damage;DamageShow(Z,Damage);src.Killed(Z)
		if(src.Class!="Ninja")	return

mob/proc/Killed(var/mob/Zombie/Z,var/SpawnTime=0,var/Spot)
	if(Z.HP<=0)
		flick("!",src.ChatBubble)
		if(!src.EnemyDowned)
			src.PlayVoice(view(WorldView,src),"Target Down")
			src.EnemyDowned=1;spawn(10)	if(src)	src.EnemyDowned=0
		src.Kills+=1
		src.TotalKills+=1
		src.KillsHUD()
		src.Exp+=1;src.LevelCheck()
		if(!src.Owner)
			src.GiveVal(1)
			src.SquadBonus(1)
		else
			src.Owner.GiveVal(1)
			src.Owner.SquadBonus(1)
		ZombiesKilled+=1
		var/AT
		if(src.Weapon)	AT=src.Weapon.AmmoType
		var/obj/Corpse/NC
		NC=new/obj/Corpse(Z,Z.BodyNum,Z.HeadIcon,Z.HeadNum,AT)
		if(Z.z==1 && Z.HeadIcon)	CorpseList+=NC
		if(Z.OnFireBy)	NC.BurnBody(Z.OnFireBy)
		spawn(SpawnTime)	if(Spot && NC)	step_away(NC,Spot)
		del Z;return NC