obj/Explosives
	icon='guns.dmi'
	density=0
	var/mob/Owner
	Mine
		icon_state="Mine"
	C4
		icon_state="C4"
	Grenade
		icon_state="Grenade"
		density=1
		New(var/mob/M,var/HighThrow)
			src.Owner=M
			src.loc=M.loc;src.dir=M.dir
			if(HighThrow)	src.density=0
			sleep(1);walk(src,src.dir,4)
			sleep(20);if(M)	Explode(src.loc,M,1)
			del src
		Bump()
			walk(src,0)
	Napalm_Grenade
		icon_state="Napalm Grenade"
		density=1
		New(var/mob/M,var/HighThrow)
			src.Owner=M
			src.loc=M.loc;src.dir=M.dir
			if(HighThrow)	src.density=0
			sleep(1);walk(src,src.dir,4)
			sleep(20);if(M)	FireBall(src.loc,M,1)
			del src
		Bump()
			walk(src,0)
	Rocket
		icon_state="Rocket"
		density=1
		New(var/mob/M,var/atom/A,var/HighThrow)
			src.Owner=M
			src.loc=M.loc;src.dir=M.dir
			if(HighThrow)	src.density=0
			sleep(1)
			if(A)	walk_towards(src,A,2)
			else	walk(src,src.dir,2)
			var/SleepTime=(get_dist(src,A)*2)+2
			if(!A)	SleepTime=14
			sleep(SleepTime)
			if(M)	Explode(src.loc,M,1)
			del src
		Bump()
			if(src.Owner)	Explode(src.loc,src.Owner,1)
			del src

mob/Player
	Meat_Decoy
		HP=100;MaxHP=1
		layer=OBJ_LAYER
		icon='guns.dmi'
		icon_state="Meat Decoy"
		density=1
		Move()
			for(var/mob/Zombie/Z in oview(WorldView,src))
				Z.MobTarget=src;if(!Z.Hunting)	Z.Hunt()
			return ..()
		New(var/mob/M,var/HighThrow)
			src.Owner=M
			src.loc=M.loc;src.dir=M.dir
			if(HighThrow)	src.density=0
			sleep(1);walk(src,src.dir,4)
			sleep(20);walk(src,0)
			sleep(300);del src
		Bump()
			walk(src,0)


var/list/ExplosionList=list()
proc/PopulateExplosionList()
	set background=1
	for(var/i=1;i<=250;i++)
		ExplosionList+=new/obj/Explosion
obj/Explosion
	density=0
	layer=MOB_LAYER+5
	icon='explosion.dmi'
proc/ShowExplosion(var/atom/Spot)
	view(WorldView,Spot)<<sound('explosion.ogg')
	var/xoff=-1;var/yoff=-1
	while(xoff<=1)
		var/obj/NE=ExplosionList[1]
		ExplosionList-=NE;ExplosionList+=NE
		NE.loc=locate(Spot.x+xoff,Spot.y+yoff,Spot.z)
		NE.icon_state="[xoff+1],[yoff+1]";xoff+=1
		if(xoff==2 && yoff<1)	{xoff=-1;yoff+=1}
		spawn(3)	NE.loc=null
proc/Explode(var/turf/Spot,var/mob/M,var/SpawnTime=1)
	ShowExplosion(Spot)
	var/counter=0
	var/Radius=2;if("Explosive Upgrade" in M.Skills)	Radius=3
	for(var/mob/Zombie/Z in view(Radius,Spot))
		counter+=1;if(counter>=10)	break
		Z.HP=0;M.Killed(Z,SpawnTime,Spot)
	for(var/obj/Corpse/C in view(2,Spot))	C.BurnBody(M)
proc/FireBall(var/turf/Spot,var/mob/M,var/SpawnTime=1)
	ShowExplosion(Spot)
	var/counter=0
	var/Radius=2;if("Explosive Upgrade" in M.Skills)	Radius=3
	for(var/mob/Zombie/Z in view(Radius,Spot))
		counter+=1;if(counter>=10)	break
		Z.SetOnFireBy(M)
	for(var/obj/Corpse/C in view(2,Spot))	C.BurnBody(M)


mob/verb/HighThrow(/**/)
	set hidden=1
	if(usr.client)	winset(usr,"MainWindow.MainMap","focus=true")
	if(!usr.CanAct)	return
	if(usr.SubWeapon=="C4")
		usr<<sound('beep.ogg')
		for(var/obj/Explosives/C4/C in world)	if(C.Owner==usr)	{Explode(C.loc,C.Owner,1);del C}
		return
	var/counter=0
	for(var/obj/Explosives/E in world)	if(E.Owner==usr)	counter+=1
	if(counter>=5 || usr.Grenades<=0)	return
	usr.Grenades-=1;usr.SubWeaponHUD()
	if(usr.SubWeapon=="Mines")
		view(WorldView,usr)<<sound('beep.ogg')
		var/obj/Explosives/Mine/M=new(usr.loc);M.Owner=usr
		usr.loc:Trapped=1
	if(usr.SubWeapon=="Grenades")	usr.ThrowProc(1)
	if(usr.SubWeapon=="Meat Decoys")	usr.ThrowMeatProc(1)
	if(usr.SubWeapon=="Napalm Grenades")	usr.ThrowNapalmProc(1)

mob/verb/Throw()
	set hidden=1
	if(usr.client)	winset(usr,"MainWindow.MainMap","focus=true")
	if(!usr.CanAct)	return
	var/counter=0
	for(var/obj/Explosives/E in world)	if(E.Owner==usr)	counter+=1
	if(counter>=5 || usr.Grenades<=0)	return
	usr.Grenades-=1;usr.SubWeaponHUD()
	if(usr.SubWeapon=="Mines")
		view(WorldView,usr)<<sound('beep.ogg')
		var/obj/Explosives/Mine/M=new(usr.loc);M.Owner=usr
		usr.loc:Trapped=1
	if(usr.SubWeapon=="C4")
		view(WorldView,usr)<<sound('beep.ogg')
		var/obj/Explosives/C4/C=new(usr.loc);C.Owner=usr
	if(usr.SubWeapon=="Grenades")	usr.ThrowProc(0)
	if(usr.SubWeapon=="Meat Decoys")	usr.ThrowMeatProc(0)
	if(usr.SubWeapon=="Napalm Grenades")	usr.ThrowNapalmProc(0)


mob/proc/FireRocket(var/atom/GotoLoc,var/HighThrow=0)
	if(!usr.CanAct)	return
	new/obj/Explosives/Rocket(usr,GotoLoc,HighThrow)

mob/proc/GrenadeStart()
	if(!src.CanAct)	return
	flick("!",src.ChatBubble)
	src.PlayVoice(view(WorldView),"Grenade")
	return 1

mob/proc/ThrowProc(var/HighThrow=0)
	if(!src.GrenadeStart())	return
	new/obj/Explosives/Grenade(src,HighThrow)

mob/proc/ThrowMeatProc(var/HighThrow=0)
	if(!src.GrenadeStart())	return
	new/mob/Player/Meat_Decoy(src,HighThrow)

mob/proc/ThrowNapalmProc(var/HighThrow=0)
	if(!src.GrenadeStart())	return
	new/obj/Explosives/Napalm_Grenade(src,HighThrow)
