mob/Player/Jobs
	icon='Jobs.dmi'
	New()
		if(src.name!="Civilian")	src.AddName()
	Del()
		for(var/obj/Job_Spawner/J in src.loc)
			if(J.JobMob==src)
				J.invisibility=0
				//world<<"<b><font color=white>The [J.name] at [J.x], [J.y] has been Lost!"
		return ..()
	Civilian
		density=0
		verb/Train()
			set src in oview(8)
			if(usr.FollowedBy==src)
				var/mob/Player/SWAT_Trooper/T=new(src.loc)
				T.name="Trained SWAT";T.AddName()
				T.verbs+=/mob/Player/Jobs/Civilian/verb/Follow
				T.verbs+=/mob/Player/Jobs/Civilian/verb/Wait
				walk_to(T,usr,1,1);usr.FollowedBy=T;T.Following=usr
				del src
			else	usr<<"I'm not Following you!"
		verb/Follow()
			set src in oview(8)
			set category=null
			set name="Follow Me!"
			if(!(src in oview(WorldView,usr)))	return
			usr.PlayVoice(usr,"Follow Me")
			if(src.Following)
				usr<<"[src]: I'm already Following [src.Following]!"
				return
			if(!usr.FollowedBy)
				src.Following=usr
				usr.FollowedBy=src
				walk_to(src,usr,1,1)
				usr<<"[src]: Alright, lets go!"
			else	usr<<"Someone is already Following you!"
		verb/Wait()
			set src in oview(8)
			set category=null
			set name="Hold Position!"
			usr.PlayVoice(usr,"Hold Position")
			if(usr.FollowedBy==src)
				src.Following=null
				usr.FollowedBy=null
				walk(src,0)
				usr<<"[src]: I'll wait here then!"
			else	usr<<"[src]: I'm not even Following you!"
		New()
			src.ChatBubble=new/obj/Supplemental/ChatBubble(src.loc)
			src.Weapon=new/obj/Guns/Hand_Guns/Beretta
			src.contents+=src.Weapon
			src.Ammos+=new/obj/AmmoTypes/Hand_Gun_Ammo
			src.Weapon.AmmoType=src.Ammos[1]
			spawn()	src.HuntZombies()
			return ..()
	Ammo_Supplier
		icon_state="Ammo Supplier"
		New()
			spawn()	src.SupplyAmmo()
			return ..()
		proc/SupplyAmmo()
			oview(WorldView)<<sound('reload.ogg')
			flick("[src.name] Job",src)
			for(var/mob/M in oview(1,src))
				for(var/obj/Guns/O in M.contents)	O.Ammo=O.MaxAmmo
				for(var/obj/AmmoTypes/O in M.Ammos)	O.Ammo=O.MaxAmmo
				M.Grenades=3;if("Grenades" in M.Skills)	M.Grenades=5
				M.SubWeaponHUD()
				M.ReloadHUD()
			spawn(150)	src.SupplyAmmo()

	Weapon_Upgrade_Service
		icon_state="Weapon Service"
		verb/Upgrade_Weapon()
			set src in oview(8)
			if(usr.ShoppingWith=="CashPoints")
				if(alert("Please be Aware, you are currently Shopping with Cash Points\
					\nAny Weapons Upgraded with Cash Points will be Destroyed if Dropped"\
					,"Cash Points","Continue","Cancel")=="Cancel")	return
			usr.UpgradeShop()

	Food_Service
		icon_state="Food Service"
		var/list/ItemList
		New()
			src.ItemList=typesof(/obj/Edible/)-/obj/Edible
			for(var/v in ItemList)	{src.ItemList-=v;src.ItemList+=new v}
			return ..()
		verb/Shop()
			set src in oview(8)
			if(usr.contents.len<usr.PackSize)
				if(usr.ShoppingWith=="CashPoints")
					if(alert("Please be Aware, you are currently Shopping with Cash Points\
						\nAny Items Purchased with Cash Points will be Destroyed if Dropped"\
						,"Cash Points","Continue","Cancel")=="Cancel")	return
				usr.ShopItems=src.ItemList
				usr.ShopProc(src.ItemList)
			else
				usr<<"Inventory Full!"
	Gun_Shop
		icon_state="Gun Shop"
		var/list/namelist=list()
		New()
			var/list/itemlist=typesof(/obj/Guns/)
			for(var/O in itemlist)	src.namelist+=new O()
			for(var/obj/O in src.namelist)
				if(!O.icon_state || istype(O,/obj/Guns/Hidden))
					src.namelist-=O;del O
			return ..()
		verb/Shop()
			set src in oview(8)
			if(usr.contents.len<usr.PackSize)
				if(usr.ShoppingWith=="CashPoints")
					if(alert("Please be Aware, you are currently Shopping with Cash Points\
						\nAny Weapons Purchased with Cash Points will be Destroyed if Dropped"\
						,"Cash Points","Continue","Cancel")=="Cancel")	return
				usr.ShopItems=src.namelist
				usr.ShopProc(src.namelist)
			else
				usr<<"Inventory Full!"

	Item_Service
		icon_state="Item Service"
		var/list/namelist=list()
		New()
			var/list/itemlist=typesof(/obj/Items/)
			for(var/O in itemlist)
				src.namelist+=new O()
			for(var/obj/O in src.namelist)
				if(O.name=="Items")
					src.namelist-=O;del O
			return ..()
		verb/Shop()
			set src in oview(8)
			if(usr.contents.len<usr.PackSize)
				if(usr.ShoppingWith=="CashPoints")
					if(alert("Please be Aware, you are currently Shopping with Cash Points\
						\nAny Items Purchased with Cash Points will be Destroyed if Dropped"\
						,"Cash Points","Continue","Cancel")=="Cancel")	return
				usr.ShopItems=src.namelist
				usr.ShopProc(src.namelist)
			else
				usr<<"Inventory Full!"
	Storage_Service
		icon_state="Storage Service"
		verb/Shop()
			set src in oview(8)
			usr.StorageShop()
	Pet_Service
		icon_state="Pet Service"
	Pet_Item_Service
		icon_state="Pet Item Service"
	Vehicle_Service
		icon_state="Vehicle Service"
		var/list/namelist=list()
		New()
			var/list/itemlist=typesof(/obj/SpecialItems/)+typesof(/obj/ShopItems/)
			for(var/O in itemlist)
				src.namelist+=new O()
			for(var/obj/O in src.namelist)
				if(O.name=="SpecialItems" || O.name=="ShopItems")
					src.namelist-=O;del O
			return ..()
		verb/Shop()
			set src in oview(8)
			if(usr.contents.len<usr.PackSize)
				if(usr.ShoppingWith=="CashPoints")
					if(alert("Please be Aware, you are currently Shopping with Cash Points\
						\nAny Items Purchased with Cash Points will be Destroyed if Dropped"\
						,"Cash Points","Continue","Cancel")=="Cancel")	return
				usr.ShopItems=src.namelist
				usr.ShopProc(src.namelist)
			else
				usr<<"Inventory Full!"
		//old shop below - for car buying only!
		/*verb/Buy_Vehicle()
			set src in oview(WorldView)
			return
			for(var/obj/SpecialItems/Car_Keys/S in usr.contents)
				usr<<"You can only use 1 vehicle at a time";return
			if(usr.contents.len>=usr.PackSize)
				usr<<"You can't carry anything else";return
			if(usr.vars[usr.ShoppingWith]<250000)
				usr.PlayMerchant('NotEnoughCash.ogg')
				usr<<"Vehicles cost 250,000 [usr.ShoppingWith].  Come back when you have enough";return
			if(usr.ShoppingWith=="CashPoints")
				if(alert("Please be Aware, you are currently Shopping with Cash Points\
					\nAny Items Purchased with Cash Points will be Destroyed if Dropped"\
					,"Cash Points","Continue","Cancel")=="Cancel")	return
			usr.PlayMerchant('WhatreYaBuyin.ogg')
			if(alert("I can sell you some transportation for 250,000 [usr.ShoppingWith]","Buy Vehicle","Buy","Cancel")=="Buy")
				if(usr.vars[usr.ShoppingWith]<250000)	return
				if(usr.contents.len>=usr.PackSize)	return
				usr.vars[usr.ShoppingWith]-=250000;usr.ValHUD()
				var/obj/SpecialItems/Car_Keys/C=new;usr.contents+=C;usr.ItemHUD()
				if(usr.ShoppingWith=="CashPoints")	C.CashPointed=1
				usr<<"Thanks for the purchase.  Click the Car Keys in your Inventory to call your ride."*/

	Banker
		icon_state="Banker"
		verb/Check_Balance()
			set src in oview(8)
			usr<<"<b>Banker:</b> You Currently have [usr.Banked] Val in the Bank"
		verb/Deposit_Val()
			set src in oview(8)
			var/amt=input("Input Amount to Deposit","Deposit Val",usr.Val)as num
			if(amt<0) amt=0
			if(amt>usr.Val)	amt=usr.Val
			usr.Val-=amt
			usr.ValHUD()
			usr.Banked+=amt
			usr.Banked=min(999999,usr.Banked)
			usr<<"<b>Banker:</b> Thanks, that brings your total Banked Amount to [usr.Banked] Val."
		verb/Withdraw_Val()
			set src in oview(8)
			var/amt=input("Input Amount to Withdraw","Withdraw Val",usr.Banked)as num
			if(amt<0) amt=0
			if(amt>usr.Banked)	amt=usr.Banked
			usr.Banked-=amt
			usr.Val+=amt;usr.ValHUD()
			usr<<"<b>Banker:</b> You have [usr.Banked] Val left in the bank,"

	Doctor
		icon_state="Medical Service"
		verb/Anti_Virus()
			set src in oview(8)
			if(alert("I can Vaccinate you for 100 Val \nOne Shot Lasts until Death!","Medical Service","Yes","No")=="Yes")
				if(get_dist(usr,src)>=WorldView)	return
				if(usr.AntiVirus || ("Immunity" in usr.Skills))
					usr<<"You've already been Vaccinated!";return
				if(usr.Val>=100)
					usr.Infected=0
					usr.AntiVirus=1
					usr.Val-=100
					usr.ValHUD()
					usr.overlays-=VirusIcon
					usr.overlays-=AntiVirusIcon
					usr.overlays+=AntiVirusIcon
					usr.PlayMerchant('ThankYou.ogg')
					usr<<"<b><font color=#66CCCC>You have been Vaccinated"
				else
					usr.PlayMerchant('NotEnoughCash.ogg')
					usr<<"You dont have enough Val!"
		verb/Heal()
			set src in oview(8)
			if(alert("I can Heal you for 10 Val","Medical Service","Yes","No")=="Yes")
				if(get_dist(usr,src)>=WorldView)	return
				if(usr.HP>=usr.MaxHP)
					usr<<"You Arent Hurt!";return
				if(usr.Val>=10)
					usr.Val-=10
					usr.ValHUD()
					usr.HP=usr.MaxHP
					usr.HealthHUD()
					usr.PlayMerchant('ThankYou.ogg')
					usr<<"<b><font color=#66CCCC>You have been Healed"
				else
					usr.PlayMerchant('NotEnoughCash.ogg')
					usr<<"You dont have enough Val!"
		verb/Vaccination()
			set src in oview(8)
			if(alert("I can Vaccinate you for 10 Val","Medical Service","Yes","No")=="Yes")
				if(get_dist(usr,src)>=WorldView)	return
				if(!usr.Infected)
					usr<<"You Arent Infected!";return
				if(usr.Val>=10)
					usr.Infected=0
					usr.Val-=10
					usr.ValHUD()
					usr.overlays-=VirusIcon
					usr.PlayMerchant('ThankYou.ogg')
					usr<<"<b><font color=#66CCCC>You have been Vaccinated"
				else
					usr.PlayMerchant('NotEnoughCash.ogg')
					usr<<"You dont have enough Val!"

obj/Job_Spawner
	icon='objects.dmi'
	icon_state="rescuepoint"
	var/RequiredCP="None"
	var/mob/Player/Jobs/JobMob
	var/JobType="/mob/Player/Jobs/Ammo_Supplier"
	verb/Assign_Job()
		set src in oview(8)
		//for(var/obj/Command_Posts/CP in CapturedCPs)	if(CP.name==src.RequiredCP)	return
		usr<<"Capture the [src.RequiredCP] to Setup this Job"
		return
		//Below Assigns jobs with civilians
		if(usr.FollowedBy)
			var/mob/Player/Jobs/Civilian/C=usr.FollowedBy
			view(WorldView)<<sound('reload.ogg')
			var/pathy=text2path("[src.JobType]")
			var/atom/A=new pathy (src.loc)
			usr.GiveVal(10)
			world<<"<b><font color=white>[usr] has setup a new [A.name] at [src.x], [src.y]!"
			del C;del src
		else	usr<<"There are no Civilians Following you!"

mob/var/ShoppingWith="Val"
mob/proc/ShopProc(var/namelist)
	src.PlayMerchant('WhatreYaBuyin.ogg')
	var/AmmoTypeTitle=""
	var/AmmoTypeListing=""
	for(var/obj/Guns/G in namelist)
		AmmoTypeTitle="<td>Ammo Type";break
	var/text="<tr><td colspan=2>Item<td>Price[AmmoTypeTitle]"
	var/counter=0
	for(var/obj/O in namelist)
		counter+=1
		if(istype(O,/obj/Guns))	AmmoTypeListing="<td>[copytext(O:AmmoTypeName,1,length(O:AmmoTypeName)-4)]"
		var/icon/I=new(O.icon,icon_state=O.icon_state,dir=SOUTH)
		src << browse_rsc(I,"[O.icon][O.icon_state]")
		text+="<tr><td><img src='[O.icon][O.icon_state]'><td><a href='?src=\ref[src];action=Buy;sec=Shop;item=\ref[O]'>[O.name]</a> 	<td>[O:Price] Val[AmmoTypeListing]"
	src<<browse({"
			<title>Shop</title>
			<body bgcolor=black>
			<center>
			<table border=1 bgcolor=gray bordercolor=black>
			[text]
			</table>
			"},"window=Shop")

mob/proc/StorageShop()
	var/text="<tr><td colspan=2>Inventory [src.contents.len]/[src.PackSize]<td>Options"
	var/counter=0
	for(var/obj/O in src.contents)
		counter+=1
		var/icon/I=new(O.icon,icon_state=O.icon_state,dir=SOUTH)
		src << browse_rsc(I,"[O.icon][O.icon_state]")
		text+="<tr><td><img src='[O.icon][O.icon_state]'><td>[O.name]<td><a href='?src=\ref[src];action=Store;sec=Storage;item=\ref[O]'>Store</a>"
	text+="<tr><td colspan=2>Storage [src.Storage.len]/[src.StorageSize]<td>Options"
	text+="<tr><td colspan=2>Extra Slot 1000 Val<td><a href='?src=\ref[src];action=Purchase;sec=Storage'>Purchase</a>"
	for(var/obj/O in src.Storage)
		counter+=1
		var/icon/I=new(O.icon,icon_state=O.icon_state,dir=SOUTH)
		src << browse_rsc(I,"[O.icon][O.icon_state]")
		text+="<tr><td><img src='[O.icon][O.icon_state]'><td>[O.name]<td><a href='?src=\ref[src];action=Take;sec=Storage;item=\ref[O]'>Take</a>"
	src<<browse({"
			<title>Storage</title>
			<body bgcolor=black>
			<center>
			<table border=1 bgcolor=gray bordercolor=black>
			[text]
			</table>
			"},"window=Storage")

proc/UpgradeLevelCalc(var/obj/Guns/choice,var/Var2Calc)
	var/CurLevel=choice.vars["[Var2Calc]Level"]
	var/MaxLevel=abs((initial(choice.vars["[Var2Calc]"])-choice.vars["Max[Var2Calc]Level"])/choice.vars["[Var2Calc]LevelUp"])
	var/ThisMax=min(99,MaxLevel)
	var/FPL="[CurLevel] / [ThisMax]"
	if(CurLevel>=MaxLevel)	FPL="Max"
	return FPL

mob/proc/UpgradeShop()
	src.PlayMerchant('WhatreYaBuyin.ogg')
	var/list/gunlist=list()
	for(var/obj/Guns/G in src.contents)
		gunlist+=G
	HTMLAlert(src,"Select Weapon to Upgrade","Upgrades",gunlist)
	if(!src)	return
	if(istype(src.Chosen,/obj/Guns))
		var/obj/Guns/choice=src.Chosen
		var/FPL=UpgradeLevelCalc(choice,"FirePower")
		var/FRL=UpgradeLevelCalc(choice,"FireRate")
		var/RTL=UpgradeLevelCalc(choice,"ReloadTime")
		var/AL=UpgradeLevelCalc(choice,"Ammo")
		var/PL=UpgradeLevelCalc(choice,"Proficiency")
		src<<browse({"
			<title>Upgrade</title>
			<body bgcolor=gray>
			<body scroll=no>
			<center>
			<table border=1 bordercolor=black bgcolor=gray width=100%>
			<tr><td colspan=6><center><b>[choice.name]

			<tr><td>Category<td>Level<td>Current<td>Max<td>Upgrades<td>Cost



			<tr>
			<td><a href='?src=\ref[src];sec=Upgrade;action=FirePower;gun=\ref[choice]'>Fire Power</a>
			<td>[FPL]<td><center>[choice.FirePower]
			<td><center>[choice.vars["MaxFirePowerLevel"]]
			<td>+[choice.FirePowerLevelUp] Damage<td>[(choice.FirePowerLevel+1)*150] Val

			<tr>
			<td><a href='?src=\ref[src];sec=Upgrade;action=FireRate;gun=\ref[choice]'>Fire Rate</a>
			<td>[FRL]<td><center>[choice.FireRate]
			<td><center>[choice.vars["MaxFireRateLevel"]]
			<td>-[choice.FireRateLevelUp] Delay<td>[(choice.FireRateLevel+1)*150] Val

			<tr>
			<td><a href='?src=\ref[src];sec=Upgrade;action=ReloadTime;gun=\ref[choice]'>Reload Time</a>
			<td>[RTL]<td><center>[choice.ReloadTime]
			<td><center>[choice.vars["MaxReloadTimeLevel"]]
			<td>-[choice.ReloadTimeLevelUp] Delay<td>[(choice.ReloadTimeLevel+1)*150] Val

			<tr>
			<td><a href='?src=\ref[src];sec=Upgrade;action=Ammo;gun=\ref[choice]'>Ammo Capacity</a>
			<td>[AL]<td><center>[choice.MaxAmmo]
			<td><center>[choice.vars["MaxAmmoLevel"]]
			<td>+[choice.AmmoLevelUp] Ammo<td>[(choice.AmmoLevel+1)*150] Val

			<tr>
			<td><a href='?src=\ref[src];sec=Upgrade;action=Proficiency;gun=\ref[choice]'>Proficiency</a>
			<td>[PL]<td><center>[choice.Proficiency]
			<td><center>[choice.vars["MaxProficiencyLevel"]]
			<td>+[choice.ProficiencyLevelUp]% HeadShot<td>[(choice.ProficiencyLevel+1)*150] Val

			</table>

			<a href='?src=\ref[src];sec=Upgrade;action=B2S'>Back To Shop</a><br>
			<a href='?src=\ref[src];sec=Upgrade;action=Cancel'>Cancel</a>
					"},"window=Upgrade,size=425x355")