obj/Supplemental/LightMap
	var/Brightness=0
	density=0
	invisibility=1
	mouse_opacity=0
	layer=MOB_LAYER+10
	icon='LightingMap.dmi'
	icon_state="0"
	proc/UpdateIS()
		src.icon_state="[LightCycle+src.Brightness]"


var/LightMapDone
proc/CreateLightMap()
	set background=1
	for(var/turf/T in world)	if(T.x>=20 || T.y>=20)	new/obj/Supplemental/LightMap(T)
	spawn()	LightCycleProc()
	LightMapDone=1

proc/GlobalLightMap()
	set background=1
	for(var/obj/Supplemental/LightMap/M in world)	M.UpdateIS()

var/LightCycle=2
var/LightCycleBumper=1
proc/LightCycleProc()
	LightCycle+=LightCycleBumper
	if(LightCycle>=10)	LightCycleBumper=-1
	if(LightCycle<=0)	LightCycleBumper=1
	spawn()	GlobalLightMap()
	spawn(600)	LightCycleProc()


proc/LightBeam(var/StartLoc,var/BeamDir,var/StartDist=0,DeLight=0)
	if(!StartLoc)	return
	var/list/InView=oview(WorldView,StartLoc)
	var/turf/Line=StartLoc
	for(var/i=1;i<=8;i++)
		Line=get_step(Line,BeamDir)
		if(i<=StartDist)	continue
		if(!(Line in InView))	break
		var/BrightenBy=round((10-get_dist(StartLoc,Line))/2)
		if(DeLight)	BrightenBy*=(-1)
		for(var/obj/Supplemental/LightMap/L in Line)
			L.Brightness+=BrightenBy
			L.UpdateIS()

mob/verb/ToggleFlashLight()
	set hidden=1
	if(!LightMapDone)	return
	src<<sound('Click.ogg')
	if(src.FlashLightOn)
		src.FlashLight(src.loc,src.dir,1)
		src.FlashLightOn=0
	else
		src.FlashLightOn=1
		src.FlashLight(src.loc,src.dir,0)

mob/var/FlashLightOn
mob/var/FlashLightDir
mob/var/turf/FlashLightLoc
mob/proc/FlashLight(var/turf/NewLoc,var/NewDir,var/DeLight=0)
	if(!src.FlashLightOn)	return
	if(DeLight)
		NewLoc=src.FlashLightLoc;NewDir=src.FlashLightDir
	else
		src.FlashLightLoc=locate(NewLoc.x,NewLoc.y,NewLoc.z);src.FlashLightDir=NewDir
	LightBeam(NewLoc,NewDir,0,DeLight)
	if(NewDir==NORTH || NewDir==SOUTH)
		LightBeam(get_step(NewLoc,WEST),NewDir,2,DeLight);LightBeam(get_step(NewLoc,EAST),NewDir,2,DeLight)
		LightBeam(GetStepDist(NewLoc,WEST,2),NewDir,4,DeLight);LightBeam(GetStepDist(NewLoc,EAST,2),NewDir,4,DeLight)
		LightBeam(GetStepDist(NewLoc,WEST,3),NewDir,6,DeLight);LightBeam(GetStepDist(NewLoc,EAST,3),NewDir,6,DeLight)
	if(NewDir==EAST || NewDir==WEST)
		LightBeam(get_step(NewLoc,NORTH),NewDir,2,DeLight);LightBeam(get_step(NewLoc,SOUTH),NewDir,2,DeLight)
		LightBeam(GetStepDist(NewLoc,NORTH,2),NewDir,4,DeLight);LightBeam(GetStepDist(NewLoc,SOUTH,2),NewDir,4,DeLight)
		LightBeam(GetStepDist(NewLoc,NORTH,3),NewDir,6,DeLight);LightBeam(GetStepDist(NewLoc,SOUTH,3),NewDir,6,DeLight)
	if(NewDir==NORTHEAST)
		LightBeam(get_step(NewLoc,NORTH),NewDir,0,DeLight);LightBeam(get_step(NewLoc,EAST),NewDir,0,DeLight)
		LightBeam(GetStepDist(NewLoc,NORTH,2),NewDir,2,DeLight);LightBeam(GetStepDist(NewLoc,EAST,2),NewDir,2,DeLight)
		LightBeam(GetStepDist(NewLoc,NORTH,3),NewDir,4,DeLight);LightBeam(GetStepDist(NewLoc,EAST,3),NewDir,4,DeLight)
	if(NewDir==NORTHWEST)
		LightBeam(get_step(NewLoc,NORTH),NewDir,0,DeLight);LightBeam(get_step(NewLoc,WEST),NewDir,0,DeLight)
		LightBeam(GetStepDist(NewLoc,NORTH,2),NewDir,2,DeLight);LightBeam(GetStepDist(NewLoc,WEST,2),NewDir,2,DeLight)
		LightBeam(GetStepDist(NewLoc,NORTH,3),NewDir,4,DeLight);LightBeam(GetStepDist(NewLoc,WEST,3),NewDir,4,DeLight)
	if(NewDir==SOUTHEAST)
		LightBeam(get_step(NewLoc,SOUTH),NewDir,0,DeLight);LightBeam(get_step(NewLoc,EAST),NewDir,0,DeLight)
		LightBeam(GetStepDist(NewLoc,SOUTH,2),NewDir,2,DeLight);LightBeam(GetStepDist(NewLoc,EAST,2),NewDir,2,DeLight)
		LightBeam(GetStepDist(NewLoc,SOUTH,3),NewDir,4,DeLight);LightBeam(GetStepDist(NewLoc,EAST,3),NewDir,4,DeLight)
	if(NewDir==SOUTHWEST)
		LightBeam(get_step(NewLoc,SOUTH),NewDir,0,DeLight);LightBeam(get_step(NewLoc,WEST),NewDir,0,DeLight)
		LightBeam(GetStepDist(NewLoc,SOUTH,2),NewDir,2,DeLight);LightBeam(GetStepDist(NewLoc,WEST,2),NewDir,2,DeLight)
		LightBeam(GetStepDist(NewLoc,SOUTH,3),NewDir,4,DeLight);LightBeam(GetStepDist(NewLoc,WEST,3),NewDir,4,DeLight)

mob/proc/SetDir(var/NewDir)
	if(src.dir==NewDir)	return
	src.FlashLight(src.loc,src.dir,1)
	src.dir=NewDir
	src.DisplayActions()
	src.FlashLight(src.loc,src.dir,0)

atom/proc/SetOpacity(var/NewOpacity)
	var/list/LightSources=list()
	var/list/FlashLights=list()
	for(var/obj/Objects/Lightable/L in oview(WorldView,src))	if(L.IsLit)	LightSources+=L
	for(var/mob/Player/P in oview(WorldView,src))	if(P.FlashLightOn)	FlashLights+=P

	for(var/obj/Objects/Lightable/L in LightSources)	L.LightSourceOff()
	for(var/mob/Player/P in FlashLights)	P.FlashLight(P.loc,P.dir,1)
	src.opacity=NewOpacity
	for(var/obj/Objects/Lightable/L in LightSources)	L.LightSourceOn()
	for(var/mob/Player/P in FlashLights)	P.FlashLight(P.loc,P.dir,0)