obj/HUD/MiniMap
	MapBG
		layer=10
		icon='MiniMap.png'
		DblClick(location,control,params)
			var/list/Params=params2list(params)
			var/list/Locs=Split(src.screen_loc,",")
			Locs+=Split(Locs[1],":")
			var/LocX=(-12+(text2num(Locs[4])-1)*32+text2num(Params["icon-x"]))*2
			var/LocY=(-12+(text2num(Locs[2])-1)*32+text2num(Params["icon-y"]))*2
			var/turf/T=locate(LocX,LocY,usr.z)
			if(!T || T.x<=20 || T.y<=20)	return
			if(T.Enter(usr))	usr.TeleportTo(T)
	MiniMapMarkers
		layer=11
		var/pixx=15
		var/pixy=15
		mouse_opacity=0
		var/atom/RefPoint
		icon='MiniMapMarkers.dmi'
		proc/CalculateScreenLoc()
			var/X=round(src.RefPoint.x*200/400)
			var/Y=round(src.RefPoint.y*200/400)
			var/FullX=round(X/32)
			var/FullY=round(Y/32)
			var/PixelX=X-(FullX*32)+11-src.pixx
			var/PixelY=Y-(FullY*32)+11-src.pixy
			src.screen_loc="MiniMap:[FullX+1]:[PixelX],[FullY+1]:[PixelY]"

proc/cMiniMapMarker(var/MyRef,var/IS,var/LifeSpan)
	var/obj/HUD/MiniMap/MiniMapMarkers/M=new()
	M.RefPoint=MyRef
	M.icon_state="[IS]"
	if(LifeSpan)	spawn(LifeSpan)	if(M)	del M
	return M

mob/verb/ToggleMiniMap()
	set hidden=1
	if(src.MiniMapOpen)
		src.MiniMapOpen=0
		winset(src,"MiniMapWindow","is-visible=false")
	else
		src.MiniMapOpen=1
		src.LoadMiniMap()
		winset(src,"MiniMapWindow","size=224x224;pos=[544-224-6],38;is-visible=true")

mob/verb/CloseMiniMap()
	set hidden=1
	src.MiniMapOpen=0

var/list/MiniMapBG
mob/proc/LoadMiniMap()
	if(!MiniMapBG)
		MiniMapBG=list()
		for(var/xx=0;xx<=6;xx++)
			for(var/yy=0;yy<=6;yy++)
				var/obj/HUD/MiniMap/MapBG/BG=new
				BG.icon_state="[xx],[yy]"
				BG.screen_loc="MiniMap:[xx+1],[yy+1]"
				MiniMapBG+=BG
	if(src.client)
		src.client.screen+=MiniMapBG
		src.MiniMapOpen=1

mob/var/MiniMapOpen
mob/var/list/MiniMapMarkers=list("Player")
mob/var/list/MiniMapObjects=list()
mob/proc/RefreshMiniMap()
	while(src)
		if(src.MiniMapOpen)
			src.client.screen-=src.MiniMapObjects
			if(!src.MiniMapMarkers["Player"])
				src.MiniMapMarkers["Player"]=cMiniMapMarker(src,"Player")
				src.MiniMapObjects+=src.MiniMapMarkers["Player"]
			src.client.screen+=src.MiniMapObjects
			for(var/obj/HUD/MiniMap/MiniMapMarkers/M in src.MiniMapObjects)	M.CalculateScreenLoc()
		sleep(2)