proc
	FullNum(var/eNum,var/ShowCommas=1)
		eNum=num2text(round(eNum),99)
		if(ShowCommas && length(eNum)>3)
			for(var/i=1;i<=round(length(eNum)/4);i++)
				var/CutLoc=length(eNum)+1-(i*3)-(i-1)
				eNum="[copytext(eNum,1,CutLoc)],[copytext(eNum,CutLoc)]"
		return eNum

mob/proc/LevelCheck()
	if(!src.client)	return
	if(src.Exp>=(src.Level)*100)
		//if(src.Level>=55)	{src.Exp=0;return}
		src.Exp=0;src.Level+=1
		src.HP=src.MaxHP
		world<<"<font color=white><b>[src] has Achieved Level [src.Level]!"

mob/proc/GiveHP(var/Amt2Give)
	src.HP+=Amt2Give
	src.HP=min(src.MaxHP,src.HP)
	src.HealthHUD()

mob/proc/GiveVal(var/Val2Give)
	src.Val+=Val2Give
	if(src.Subscriber)	src.Val+=Val2Give
	if(src.client)	src.ValHUD()

mob/proc/FullReSupply()
	src.HP=src.MaxHP;src.HealthHUD()
	src.Grenades=3
	if(src.Weapon)
		src.Weapon.Ammo=src.Weapon.MaxAmmo
		src.Weapon.AmmoType.Ammo=src.Weapon.AmmoType.MaxAmmo
		src.ReloadHUD()

mob/proc/DeathReset()
	src.HP=src.MaxHP
	src.Infected=0;src.overlays-=VirusIcon
	src.AntiVirus=0;src.overlays-=AntiVirusIcon
	src.Grenades=3;if("Grenades" in src.Skills)	src.Grenades=5
	src.Kills=0;src.KillsHUD()
	src.ResetIS();src.ClassItemDelete()
	for(var/obj/Guns/O in src.contents)	O.Ammo=O.MaxAmmo
	for(var/obj/AmmoTypes/O in src.Ammos)	O.Ammo=O.MaxAmmo

	src.NightVision=0
	src.ThermalVision=0
	src.sight=initial(src.sight)

	if(src.FollowedBy)
		walk(src.FollowedBy,0)
		src.FollowedBy.Following=null;src.FollowedBy=null

mob/proc/UpdateMusic(/**/)
	src<<sound(null)
	if(!src.MusicOn)	return
	if(src.loc==TalentScreen)
		//src<<sound('PrayFFT.mid',repeat=1)
		src<<sound('ParadiseCityGnR.mid',repeat=1)
	else
		if(DayPart==1)	src<<sound('NightBFM.mid',repeat=1)
		if(DayPart==2)	src<<sound('EndingCreditsFFT.mid',repeat=1)
		if(DayPart==3)	src<<sound('MonestaryFFT.mid',repeat=1)
		if(DayPart!=4 && Raining)	src<<sound('LightRainLoop.ogg',repeat=1)
		if(DayPart==4)
			src<<sound('TensionFFT.mid',repeat=1)
			if(Raining)	src<<sound('HeavyRainLoop.ogg',repeat=1)

mob/proc/MaxUpgradeWeapon()
	if(!src.Weapon)	return
	var/obj/Guns/G=src.Weapon
	G.FireRate-=G.FireRateLevelUp*G.MaxFireRateLevel
	G.ReloadTime-=G.ReloadTimeLevelUp*G.MaxReloadTimeLevel
	G.FirePower+=G.FirePowerLevelUp*G.MaxFirePowerLevel
	G.Proficiency+=G.ProficiencyLevelUp*G.MaxProficiencyLevel
	G.MaxAmmo+=G.AmmoLevelUp*G.MaxAmmoLevel

mob/proc/CashPointDrop(var/obj/O)
	if(O.CashPointed)
		var/Choice=alert(src,"Cash Points were used on this item. \nIf you drop it, it will be Destroyed!"\
			,"$ Drop Warning","Drop","Keep")
		if(Choice=="Drop")	return 1
		else	return 0
	return 1

mob/proc/Respec(/**/)
	src.Respawn()
	src.CanAct=0
	src.HP=src.MaxHP;src.PackSize=5
	src.Clicked=0
	flick("",src.ChatBubble)
	src.icon=null;src.loc=TalentScreen
	src.verbs-=/mob/Downed/verb/Drag
	src.UpdateMusic()
	src.ClearHUD()
	src.overlays=list()
	src.SkillHud()

mob/proc/Respawn(/**/)
	if(src.FlashLightOn)	src.ToggleFlashLight()
	if(src.Vehicle)
		src.MovementSpeed=2
		src.Vehicle.Passanger=null;src.Vehicle=null
	if(src.client)	src.client.eye=src
	if(src.HpBar)
		src.overlays-=src.HpBar
		src.HpBar.icon_state="33"
	if(src.AmmoBar)
		src.overlays-=src.AmmoBar
		src.AmmoBar.icon_state="33"
	src.loc=locate(rand(326,329),rand(372,374),1)
	src.Move(null)
	src.SubWeaponHUD()
	src.HealthHUD()
	src.ReloadHUD()
	src.EquipHUD()

var/obj/Supplemental/DownedIcon/DownedIcon=new

obj/Supplemental/DownedIcon
	icon='Effects.dmi'
	icon_state="Downed"
	layer=25

proc/cTeleLink(var/atom/A)
	return "<a href='?src=\ref[usr];Action=TeleLink;TeleportTo=\ref[A]'>"

mob/proc/DownPlayer(/**/)
	if(src.Downed)	return
	src.dir=SOUTH
	src.overlays+=DownedIcon
	src.Downed=1;src.ResetIS()
	src.CanAct=0;src.CanMove=0
	src.HP=src.MaxHP;src.HealthHUD()
	src.verbs+=/mob/Downed/verb/Drag
	src.verbs+=/mob/Downed/verb/Revive
	var/FoundCP=FindCP(src)
	var/Loc2Say="at [cTeleLink(src)][src.x],[src.y]</a>"
	if(FoundCP)	Loc2Say="at the [cTeleLink(src)][FoundCP]</a>"
	world<<"<b><font color=red>[src] has been Downed by Zombies [Loc2Say]!"
	src<<"<b><font color=red>Press 8 to Call for Help.  Press V to Attack.  Press X to Commit Suicide =("

proc/FindCP(var/atom/A)
	for(var/obj/Command_Posts/CP_Spawner/CP in oview(WorldView,A))	return CP.name

mob/proc/RevivePlayer(var/mob/M)
	if(!src.Downed)	return
	src.dir=SOUTH
	src.HP=src.MaxHP;src.HealthHUD()
	src.overlays-=DownedIcon
	src.Downed=0;src.ResetIS()
	src.CanAct=1;src.CanMove=1
	src.verbs-=/mob/Downed/verb/Drag
	src.verbs-=/mob/Downed/verb/Revive
	src.BeingRevived=0;src.overlays-=src.CapBar
	if(M)
		world<<"<b><font color=white>[M] has helped [src] back onto their feet."
		M.PlayVoice(view(WorldView,M),"Lets Move")

mob/proc/ResetIS(/**/)
	if(!istype(src,/mob/Player/Drones))
		src.icon_state=""
		if(src.Weapon)	if("[src.Weapon]" in icon_states(src.icon))	src.icon_state="[src.Weapon]"
		if(src.RcD)	src.icon_state="RC"
		if(src.Vehicle)	src.icon_state="In Car"
		if(src.loc && src.loc:name=="Water")	src.icon_state="Swim"
		if(src.Downed)	src.icon_state="Downed"

mob/proc/AddHead(/**/)
	usr=src
	for(var/O in usr.overlays)
		if(O:name=="Head")	usr.overlays-=O
	if(src.HeadID!="Full_Ironman")
		if(!(src.HeadID in HeadList))
			if(src.gender=="female")	src.HeadID="Female"
			else	if(src.gender=="male")	src.HeadID="Default"
			else	src.HeadID="Pumpkin"
		var/obj/NH=new/obj;NH.name="Head"
		if(src.MyInvis)	NH.icon=InvisHeads["[src.HeadID]"]
		else
			if(src.HeadID=="Default")	NH.icon='Head1.dmi'
			if(src.HeadID=="Pilot")	NH.icon='Head2.dmi'
			if(src.HeadID=="SWAT")	NH.icon='Head3.dmi'
			if(src.HeadID=="Female")	NH.icon='Head4.dmi'
			if(src.HeadID=="Batman")	NH.icon='Head5.dmi'
			if(src.HeadID=="Ironman")	NH.icon='Head6.dmi'
			if(src.HeadID=="Shades")	NH.icon='HeadShades.dmi'
			if(src.HeadID=="Pumpkin")	NH.icon='HeadPumpkin.dmi'
			if(src.HeadID=="Spartan")	NH.icon='HeadSpartan.dmi'
			if(src.HeadID=="Blonde")	NH.icon='HeadBlonde.dmi'
			if(src.HeadID=="Bill")	NH.icon='HeadBill.dmi'
			if(src.HeadID=="Ninja")	NH.icon='HeadNinja.dmi'
			if(src.HeadID=="Doctor")	NH.icon='HeadDoctor.dmi'
		NH.layer=MOB_LAYER+1
		usr.layer=MOB_LAYER+2
		usr.overlays+=NH

proc/WorldStatusUpdate()
	world.status="(v[GameVersion]) [Players.len]/[PlayerLimit] Players"

var/list/CorpseList=list()
proc/StartGame()
	spawn(/*300*/)
		spawn()	ZombieSpawner()
		spawn()	ZombieSpawner()
		spawn()	ZombieSpawner()

proc/ZombieSpawner()
	set background=1
	if(Zombies.len<ZombieMax)
		var/mob/Zombie/Z=new
		Z.LocateZombie(1)
	else	sleep(100)
	spawn(rand(1,5))	ZombieSpawner()

mob/Zombie/proc/LocateZombie(var/InitialSpawn=0)
	var/atom/CL
	if(rand(1,2+CorpseList.len)>2+round(CorpseList.len/2))	CL=pick(CorpseList)
	else
		if(DayTime || InitialSpawn)
			RePick
			CL=TurfSpawnList[rand(1,TurfSpawnList.len)]
			for(var/mob/Zombie/Z in locate(CL.x,CL.y,CL.z))	goto RePick
			for(var/mob/Player/M in oview(WorldView,CL))	goto RePick
		else
			var/list/NightSpawnPoints=list()
			for(var/v in NightPoint.SpawnPoints)
				for(var/mob/Zombie/Z in oview(0,v))	goto OCCUPIED
				NightSpawnPoints+=v;OCCUPIED
			if(!NightSpawnPoints.len)	{src.LocateZombie(1);return}
			CL=pick(NightSpawnPoints)
	src.loc=locate(CL.x,CL.y,CL.z)
	if(istype(CL,/obj/Corpse))	{CorpseList-=CL;del CL}

proc/CheckMaxCPU()
	if(world.cpu<=MaxCPU)	return 1
	return 0

proc/GetStepDist(var/Loc,var/Dir,var/Dist)
	for(var/i=1;i<=Dist;i++)	Loc=get_step(Loc,Dir)
	return Loc

proc/RandomWeather()
	set background=1
	return
	var/MaxProb=3
	if(Raining)	MaxProb=2
	if(rand(1,MaxProb)==1)
		Raining=!Raining
		if(!Raining)
			world<<"<font color=white>The rain seems to be letting up..."
			for(var/obj/Supplemental/Weather/R in world)	R.icon_state="invis"
		else
			world<<"<font color=white>It has begun to rain..."
			for(var/obj/Supplemental/Weather/RainOver/R in world)	R.icon_state="Rain"
			for(var/obj/Supplemental/Weather/RainDrop/R in world)	R.icon_state="RainDrop[rand(1,10)]"
		for(var/mob/Player/M in Players)	M.UpdateMusic()

proc/TimeLoop()
	DayPart+=1
	spawn()	RandomWeather()
	if(DayPart>=5)	DayPart=1
	//for(var/mob/Player/M in world)	if(M.client)	M.Move(null)
	for(var/mob/Player/M in Players)	M.UpdateMusic()
	for(var/obj/Command_Posts/CP_Spawner/C in world)
		for(var/mob/Player/Command_Post/X in C.loc)
			var/mob/Player/Recap_Post/NCP=new(C.loc);NCP.name=C.name
			del X;goto AlreadyHere
		for(var/mob/Player/Recap_Post/X in C.loc)	goto AlreadyHere
		for(var/obj/Command_Posts/Command_Post/X in C.loc)	goto AlreadyHere
		var/obj/Command_Posts/Command_Post/NCP=new(C.loc);NCP.name=C.name
		AlreadyHere
	if(DayPart==1)
		DayTime=1;Days+=1
		world<<"<font color=white>The sun has begun to rise..."
		for(var/obj/Command_Posts/Civilian_Spawner/C in world)
			for(var/mob/Player/Jobs/Civilian/X in C.loc)	goto NoCiv
			new/mob/Player/Jobs/Civilian(C.loc);NoCiv
	if(DayPart==2)	world<<"<font color=white>The sun sits directly overhead..."
	if(DayPart==3)
		var/list/CommandPosts=list()
		for(var/obj/Command_Posts/CP_Spawner/P in world)	CommandPosts+=P
		NightPoint=pick(CommandPosts)
		world<<"<font color=white>The sun has begun to set...  <b>It looks like Zombies are amassing near the [cTeleLink(NightPoint.loc)][NightPoint]</a>!  We should set up what defenses we can for tonight..."
		spawn(2400)
			world<<sound('TeamFallBack.ogg')
			//world<<"<font color=white>Only 1 Minute until Sunset!  Hurry back to HQ or youll be left out in the dark!"
			//world<<"<font color=white>Only 1 Minute until Sunset!  Evac-Choppers have been Dispatched!"
			world<<"<font color=white>Only 1 Minute until Sunset!  <b>The horde will raid the [cTeleLink(NightPoint.loc)][NightPoint]</a> soon!"
	if(DayPart==4)
		DayTime=0
		world<<"<font color=white>The sun has dissapeared over the horizon... <b>The Zombie Horde is raiding the [cTeleLink(NightPoint.loc)][NightPoint]</a>!"
		CorpseList=list()
		/*for(var/mob/Player/M in Players)
			if(M.loc!=TalentScreen)
				M.loc=locate(rand(136,139),rand(183,185),1)
				M<<"The evac-choppers have brought you back to HQ!"*/
		spawn()	NightSummon()
	spawn(3000)	TimeLoop()

mob/proc/PlayMerchant(var/Voices)
	//if(src.MerchantPlaying)	return
	//src.MerchantPlaying=1
	//spawn(20)	usr.MerchantPlaying=0
	src<<sound(pick(Voices),channel=5)

obj/Supplemental/SpawnLoc
	icon='Other.dmi';icon_state="EnemySpawn"
	New()	src.icon_state="invis"

var/obj/Command_Posts/CP_Spawner/NightPoint
proc/NightSummon()
	set background=1
	var/counter=0
	for(var/mob/Zombie/Z in world)
		var/obj/PickedLoc=pick(NightPoint.SpawnPoints);Z.loc=PickedLoc.loc
		counter+=1;if(counter>=NightPoint.SpawnPoints.len)	return
		//min(1000,round(ZombieMax/2))	old max

mob/var/Chosen
mob/var/WindowUp=0
proc/HTMLAlert(var/mob/M,var/Message,var/Title,var/Options)
	if(M.WindowUp)	return
	M.WindowUp=1
	var/text="<html><title>[Title]</title><body bgcolor=gray><center>"
	text+="<table border=1 bgcolor=gray bordercolor=black width=100%><tr><td colspan=2>[Message]"
	for(var/obj/O in Options)
		var/icon/I=new(O.icon,icon_state=O.icon_state,dir=SOUTH)
		M << browse_rsc(I,"[O.icon][O.icon_state]")
		text+="<tr><td><img src='[O.icon][O.icon_state]'>"
		text+="<td><a href='?src=\ref[M];action=Choose;Chosen=\ref[O]'>[O.name]</a>"
	M<<browse({"
			[text]
			</table>
			"},"window=Choose;can_close=no")
	M.Chosen=null
	while(!M.Chosen)
		sleep(1);if(!M)	return
	M.WindowUp=0

mob/var/PlayingSound
mob/proc/PlayZombieSound(var/mob/Zombie/Z)
	var/PlayDist=100-((get_dist(Z,src)-1)*5)
	if(istype(src,/mob/Player/Drones))	src=src:Owner
	if(!src)	return
	if(src.PlayingSound || !src.client)	return
	src<<sound(pick(ZombieSoundList),volume=PlayDist)
	src.PlayingSound=1
	spawn(rand(5,15))	if(src)	src.PlayingSound=0

proc/ZombieSounds()
	return
	world<<sound(pick(ZSList1+ZSList2+ZSList3+ZSList4))
	spawn(rand(5,15))	ZombieSounds()