mob/proc/GetScreenX(var/atom/A)
	return A.x-src.x
mob/proc/GetScreenY(var/atom/A)
	return A.y-src.y

obj/Skill
	icon='Skills.dmi'
	Click()
		alert("Drag Skills into Slots on the Right to Equip.","Skill Info")
	MouseEntered()
		if(src.desc)
			var/X=usr.GetScreenX(src);var/Xoff=src.pixel_x
			var/Y=usr.GetScreenY(src);var/Yoff=src.pixel_y
			X*=32;Y=(17-Y)*32
			winset(usr,"SmallInfoWindow.NameLabel","text=\"[src.name]\"")
			winset(usr,"SmallInfoWindow.DescLabel","text=\"[src.desc]\"")
			winset(usr,"SmallInfoWindow","pos=[16+X+Xoff],[38+Y-Yoff];is-visible=true")
			winset(usr,"MainWindow.MainMap","focus=true")
	MouseExited()
		if(src.desc)	winset(usr,"SmallInfoWindow","is-visible=false")

	SubWeapon
		layer=4
		New()
			src.mouse_drag_pointer=src.icon_state
		MouseDrop(var/obj/varx)
			if(istype(varx,/obj/Skill/BlankSubWeapon) && istype(src,/obj/Skill/SubWeapon))
				usr.SubWeapon=src.name
				varx.mouse_drag_pointer=src.icon_state
				varx.icon_state=src.icon_state
	ClassSelect
		layer=4
		New()
			src.mouse_drag_pointer=src.icon_state
		MouseDrop(var/obj/varx)
			if(istype(varx,/obj/Skill/BlankClass) && istype(src,/obj/Skill/ClassSelect))
				usr.Class=src.icon_state
				varx.mouse_drag_pointer=src.icon_state
				varx.icon_state=src.icon_state
	Selection
		layer=4
		var/SubOnly=0
		New()
			src.icon_state=src.name
			src.mouse_drag_pointer=src.icon_state
		MouseDrop(var/obj/varx)
			if(istype(varx,/obj/Skill/Blank) && istype(src,/obj/Skill/Selection))
				if(src.icon_state in usr.Skills)
					usr<<"You Already Know This Skill!";return
				if(src.SubOnly && !usr.Subscriber)
					usr<<"Skill for Subscribers Only!";return
				if(varx.icon_state!="Blank")	usr.Skills-=varx.icon_state
				usr.Skills+=src.icon_state
				varx.mouse_drag_pointer=src.icon_state
				varx.icon_state=src.icon_state
		Unknown
			desc="Unknown"
		MacGyver
			desc="Repair Broken Objects without Tools"
		Hot_Wire
			desc="Start Vehicles without Keys"
		Mechanical
			desc="Quicker Repair Times"
		Pyromaniac
			desc="Start Fires without a Lighter"

		Grenades
			desc="Spawn with 2 extra Grenades"
		Side_Pack
			desc="Expand Inventory by 2 Slot"
		Thermal_Goggles
			desc="See Zombies through Walls"
		Incineration_Shoes
			desc="Stepping on Corpses will Auto-Burn"

		Hand_Gun_Proficiency
			desc="Raises Proficiency With Hand Guns"
		Shot_Gun_Proficiency
			desc="Raises Proficiency With Shot Guns"
		Machine_Gun_Proficiency
			desc="Raises Proficiency With Machine Guns"
		Knife_Proficiency
			desc="Raises Proficiency With Knives"

		Class_Upgrade_A
			icon_state="Class Upgrade A"
			desc="Upgrades Class Skills:\n\
				Medic: Deploy Medic Station\n\
				Support: Stock Fire Ammo\n\
				Engineer:  Rocket Launcher Turret\n\
				Commander:  Upgraded SWAT Weapons\n\
				Ninja:  Radial Death Slash"
		Class_Upgrade_B
			icon_state="Class Upgrade B"
			desc="Upgrades Class Skills:\n\
				Medic: Self Revive\n\
				Support:  Energy Barriers\n\
				Engineer:  Repair Everything\n\
				Commander:  Ranged CP Capture\n\
				Ninja:  Extended Stealth"
		Explosive_Upgrade
			icon_state="Explosive Upgrade"
			desc="Increase Damage Radius of Explosives"

obj/Skill
	icon='Skills.dmi'
	Outline
		icon_state="Skill Outline"
	BlankSubWeapon
		icon_state="Blank"
		Click()
			for(var/obj/Skill/SubWeapon/O in oview(WorldView,usr))
				if(O.icon_state==src.icon_state && O!=src)	O.Click()
		New(var/varx,var/IS)
			if(!IS)	src.icon_state="Blank"
			else	src.icon_state=IS
			src.screen_loc="12,6"
	BlankClass
		icon_state="Blank"
		Click()
			for(var/obj/Skill/ClassSelect/O in oview(WorldView,usr))
				if(O.icon_state==src.icon_state && O!=src)	O.Click()
		New(var/varx,var/IS)
			if(!IS)	src.icon_state="Blank"
			else	src.icon_state=IS
			src.screen_loc="12,4"
	Blank
		icon_state="Blank"
		Click()
			for(var/obj/Skill/Selection/O in oview(WorldView,usr))
				if(O.icon_state==src.icon_state && O!=src)	O.Click()
		New(var/varx,var/IS)
			if(!IS)	src.icon_state="Blank"
			else	src.icon_state=IS
			src.screen_loc="[9+varx],11"
	Instructions
		icon='inst.png'
	Go
		//GO
		icon_state="Go"
		Click()
			if(usr.Clicked)	return
			usr.AddClassIcon()
			usr.Clicked=1
			usr.ClearHUD()
			usr.icon='player.dmi'
			usr.CanAct=1
			usr.Infected=0
			usr.HP=usr.MaxHP
			if("Side Pack" in usr.Skills)	usr.PackSize+=2
			if(usr.AntiVirus || ("Immunity" in usr.Skills))
				usr.overlays-=AntiVirusIcon;usr.overlays+=AntiVirusIcon
			usr.ClassItemDelete()
			usr.AddClothes()
			usr.AddName()
			usr.AddSquad()
			usr.Respawn()
			usr.AddHead()
			usr.HUDBG()
			usr.ResetHUDText()
			usr.Move(null)
			usr.UpdateMusic()
			if(!usr.FlashLightOn)	usr.ToggleFlashLight()

turf/skills
	BG
		//icon='RespecBGjpg.jpg'
		icon='Title3jpg.jpg'
		density=1

mob/proc/AddClassIcon(/**/)
	var/obj/ClassIcon
	if(src.Class=="Medic")	ClassIcon=MedicIcon
	if(src.Class=="Support")	ClassIcon=SupportIcon
	if(src.Class=="Engineer")	ClassIcon=EngineerIcon
	if(src.Class=="Commander")	ClassIcon=CommanderIcon
	if(src.Class=="Ninja")	ClassIcon=NinjaIcon
	if(!ClassIcon)
		src<<"Please Select a Class";return
	for(var/v in src.overlays)	if(v:name=="ClassIcon")
		src.overlays-=v
	var/Name2Add=src.name
	if(findtext(Name2Add,"@"))	Name2Add=copytext(Name2Add,1,findtext(Name2Add,"@"))
	var/xoff=-4-(length(Name2Add)*6)/2
	ClassIcon.name="ClassIcon"
	ClassIcon.pixel_x=xoff;src.overlays+=ClassIcon
	if(src.Subscriber)
		ClassIcon=SubIcon;ClassIcon.name="ClassIcon"
		xoff=5+(length(Name2Add)*6)/2
		ClassIcon.pixel_x=xoff;src.overlays+=ClassIcon