var/list/SquadList=list()
var/list/LockedSquads=list()
var/SquadStarter=new/obj/Squads/Start_Squad
mob/var/obj/Squads/Squad/Squad
mob/var/list/SquadInvites=list()

mob/proc/LeaveSquad(/**/)
	for(var/mob/M in src.Squad.Members)	M<<"[src] has Left the Squad"
	src.Squad.Members-=src
	for(var/obj/SquadMember/S in src.Squad.ObjMembers)
		if(S.MobRef==src)	{src.Squad.ObjMembers-=S;del S}
	if(src.Squad.Members.len)
		src.Squad.suffix="([src.Squad.Members.len] Members)"
		if(src.Squad.Leader==src)
			src.Squad.Leader=src.Squad.Members[1]
			src.Squad.name="[src.Squad.Leader]'s Squad"
			for(var/mob/M in src.Squad.Members)	M.AddSquad()
	else
		LockedSquads-=src.Squad
		SquadList-=src.Squad
		del src.Squad
	src.Squad=null
	src.AddSquad()

mob/proc/SquadBonus(var/Bonus=0)
	if(src.Squad)	for(var/mob/M in src.Squad.Members-src)
		if(get_dist(src,M)<=WorldView)
			M.GiveVal(Bonus)
			src.GiveVal(Bonus)

obj/SquadMember
	var/mob/Player/MobRef
	New(var/mob/M)
		src.name=M.name
		src.MobRef=M
		src.loc=null
	Click()
		if(!usr.Squad || usr.Squad.Leader!=usr)	return
		var/Choice=alert(usr,"Choose an Action","Manage Squad Members","Kick","Goto","Cancel")
		if(!usr.Squad || usr.Squad.Leader!=usr || !src.MobRef)	return
		if(Choice=="Kick")
			for(var/mob/M in usr.Squad.Members)	M<<"[usr] has Kicked [src.MobRef] from the Squad"
			src.MobRef.LeaveSquad()
		if(Choice=="Goto")	usr.TeleportTo(src.MobRef)

obj/SquadInvite
	var/InitName
	var/obj/Squads/Squad/SquadRef
	New(var/obj/Squads/Squad/S)
		src.loc=null
		src.SquadRef=S
		src.InitName=S.name
		src.name="Invite to [S.name]"
	Click()
		src.Accept()
	verb/Accept()
		set src in world
		if(src.SquadRef && src.SquadRef.name==src.InitName)	usr.JoinSquad(src.SquadRef)
		else	usr<<"[src.name] Expired"
		usr.SquadInvites-=src;del src
	verb/Decline()
		set src in world
		if(src.SquadRef && src.SquadRef.name==src.InitName)
			src.SquadRef.Leader<<"[usr] Declined your Squad Invite"
		usr<<"[src.name] Declined"
		usr.SquadInvites-=src;del src

mob/Player/PlayerOnly/verb
	Invite()
		set src in oview(8)
		if(src.Squad)
			usr<<"[src] is Already in a Squad";return
		if(!usr.Squad || usr.Squad.Leader!=usr)
			usr<<"You must be a Squad Leader to Invite Members";return
		if(usr.Squad.Members.len>=5)
			usr<<"Your Squad is Already Full";return
		for(var/obj/SquadInvite/S in src.SquadInvites)	if(S.InitName==usr.Squad.name)
			usr<<"[src] Already has a Pending Invite from your Squad";return
		usr<<"Squad Invite Sent to [src]"
		src<<"[usr] has Invited you to Join their Squad"
		src<<"Check the Squads Tab to Accept or Decline"
		src.SquadInvites+=new/obj/SquadInvite(usr.Squad)

var/obj/Supplemental/GlobalInviter/GlobalInvite=new
obj/Supplemental/GlobalInviter
	name="<b>Click Here to Send Global Invites"
	Click()
		if(!usr.Squad || usr.Squad.Leader!=usr)
			usr<<"You must be a Squad Leader to Invite Members";return
		if(usr.Squad.Members.len>=5)
			usr<<"Your Squad is Already Full";return
		var/InvitesSent=0
		for(var/mob/Player/M in Players-usr)
			if(M.Squad)	continue
			for(var/obj/SquadInvite/S in M.SquadInvites)	if(S.InitName==usr.Squad.name)	goto Continue
			M<<"[usr] has Invited you to Join their Squad"
			M<<"Check the Squads Tab to Accept or Decline"
			M.SquadInvites+=new/obj/SquadInvite(usr.Squad)
			InvitesSent+=1;Continue
		usr<<"Invites Sent to [InvitesSent] Applicable Players"

mob/proc/TeleportTo(var/mob/M)
	if(ismob(M))
		if(M.loc==TalentScreen)
			src<<"[M] is Currently at the Class Customization Screen...";return
		if(M.icon_state=="Swim")
			src<<"[M] is Currently Swimming.  Unable to Transport";return
	if(src.Vehicle)
		src<<"Cannot Transport while inside a Vehicle...";return
	if(!src.CanAct)
		src<<"Unable to Transport at the Moment...";return
	src.GenericLoc(M)
	walk_to(src,M,1,1)
	if(src.FollowedBy)	src.FollowedBy.loc=src.loc

mob/proc/JoinSquad(var/obj/Squads/Squad/S)
	if(src.Squad)
		src<<"You are Already in a Squad";return
	if(S.Members.len>=5)
		src<<"This Squad is Already Full";return
	src.Squad=S
	src.SquadInvites=list()
	src.Squad.Members+=src
	for(var/mob/M in src.Squad.Members)	M<<"[src] has Joined the Squad"
	src.Squad.ObjMembers+=new/obj/SquadMember(src)
	src.Squad.suffix="([src.Squad.Members.len] Members)"
	src.AddSquad()

obj/Squads
	Squad
		New()
			src.verbs-=/obj/Squads/Squad/verb/UnLock_Squad
			return ..()
		var/mob/Leader
		var/list/Members=list()
		var/list/ObjMembers=list()
		verb/Goto_Leader()
			set src in world
			if(usr.Squad==src)
				usr<<sound('Chopper.ogg')
				usr.TeleportTo(usr.Squad.Leader)
			else	usr<<"You must be a Member of this Squad to Teleport to the Squad Leader"
		verb/Join_Squad()
			set src in world
			if(src in LockedSquads)
				usr<<"This Squad is Locked.  You can only Join if Invited.";return
			usr.JoinSquad(src)
		verb/Leave_Squad()
			set src in world
			if(usr.Squad==src)
				usr.LeaveSquad()
		verb/Lock_Squad()
			set src in world
			if(src.Leader!=usr)
				usr<<"Only Available to Squad Leaders";return
			SquadList-=src;LockedSquads+=src
			usr<<"Players can now Join by Invite Only"
			src.verbs-=/obj/Squads/Squad/verb/Lock_Squad
			src.verbs+=/obj/Squads/Squad/verb/UnLock_Squad
		verb/UnLock_Squad()
			set src in world
			if(src.Leader!=usr)
				usr<<"Only Available to Squad Leaders";return
			SquadList+=src;LockedSquads-=src
			usr<<"Anyone can now Join your Squad"
			src.verbs+=/obj/Squads/Squad/verb/Lock_Squad
			src.verbs-=/obj/Squads/Squad/verb/UnLock_Squad
		verb/View_Members()
			set src in world
			var/Text="<body bgcolor=gray><center><table border=1 bordercolor=black width=100%>"
			Text+="<tr><td colspan=5><center>[src.Members.len] Members"
			Text+="<tr><td><b>Player<td><b>Level<td><b>Kills<td><b>Weapon"
			var/mob/X=src.Leader
			Text+="<tr><td>[X.name]<td>[X.Level]<td>[X.Kills]<td>[X.Weapon]"
			for(var/mob/Player/M in src.Members-src.Leader)
				Text+="<tr><td>[M.name]<td>[M.Level]<td>[M.Kills]<td>[M.Weapon]"
			Text+="<tr><td colspan=5><center>[src.Members.len] Members"
			usr<<browse(Text,"window=Squad")

	Start_Squad
		name="Create a Squad"
		verb/Create_Squad()
			set src in world
			if(usr.Squad)	return
			usr.Squad=new/obj/Squads/Squad
			usr.Squad.Members+=usr
			usr.Squad.ObjMembers+=new/obj/SquadMember(usr)
			usr.Squad.Leader=usr
			usr.Squad.name="[usr]'s Squad"
			usr.Squad.suffix="([usr.Squad.Members.len] Members)"
			SquadList+=usr.Squad
			usr.AddSquad()
