mob/var/AFK=0
var/obj/Supplemental/AFK/AFKIcon=new()
obj/Supplemental/AFK
	icon='Other.dmi'
	icon_state="AFK"
	layer=FLOAT_LAYER

var/obj/Supplemental/StatExpander/TabGenericStats=new("Generic")
var/obj/Supplemental/StatExpander/TabWeaponStats=new("Weapon")
var/obj/Supplemental/StatExpander/TabSpecStats=new("Spec")
obj/Supplemental/StatExpander
	var/Stats2Show="Generic"
	New(var/Stats2ShowN)
		src.Stats2Show=Stats2ShowN
		src.name="<b>\[-\] Hide [src.Stats2Show] Stats"
	Click()
		var/CurSetting=usr.vars["Show[src.Stats2Show]Stats"]
		usr.vars["Show[src.Stats2Show]Stats"]=!CurSetting
		if(CurSetting)	src.name="<b>\[+\] Show [src.Stats2Show] Stats"
		else	src.name="<b>\[-\] Hide [src.Stats2Show] Stats"

mob/proc/SecondLoop()
	while(src)
		if(src.Downed)	if(!src.BeingRevived)
			src.HP-=1;src.HealthHUD()
			if(src.HP<=0)	src.DeathCheck("Downed")
		else	if("Regeneration" in src.Skills)
			src.GiveHP(round(src.MaxHP/rand(10,20)))
		sleep(10)

mob/Player/Stat()
	if(src.client.inactivity/10>=300)
		if(!src.AFK && src.icon)
			src.overlays-=AFKIcon;src.overlays+=AFKIcon
			src.AFK=1;src<<"Switching to AFK Mode"
	else	if(src.AFK)
		src.overlays-=AFKIcon
		src.AFK=0;src<<"Returning from AFK Mode"

	//Begin actual Stat Panels
	if(statpanel("Squads"))
		stat("<b>*Right Click...","<b>Squad Selections")
		if(src.Squad)
			stat("<b>Your Squad:",src.Squad)
			if(src.Squad.Leader==src)
				stat(GlobalInvite)
				stat("","<b>Left Click to Manage Members")
			else	stat("","<b>Members")
			stat(src.Squad.ObjMembers)
		else	stat("<b>Your Squad:",SquadStarter)
		stat("[SquadList.len] Open Squads:","----- --- ----- --- ----- --- -----")
		stat(SquadList)
		stat("[SquadInvites.len] Squad Invites:","----- --- ----- --- ----- --- -----")
		stat(SquadInvites)
		stat("[LockedSquads.len] Locked Squads:","----- --- ----- --- ----- --- -----")
		stat(LockedSquads)
		stat("<b>*Right Click...","<b>Squad Selections")
		stat("Squad Bonus Info:","")
		stat("","<b>Val Received in a Squad will be Multiplied by nearby Members.")
		stat("","<b>All Squad Members in View will also Receive Val.")

	if(statpanel("Transport"))
		stat("","<b>Right Click Targets to Transport")
		stat("<b>Raid:","<b>Command Post")
		stat(NightPoint)
		stat("<b>Players:","<b>[Players.len] Online")
		stat(Players)
		stat("<b>UnCaptured:","<b>[UnCapturedCPs.len] / [CapturedCPs.len+UnCapturedCPs.len] Command Posts")
		stat(UnCapturedCPs)
		stat("<b>Captured:","<b>[CapturedCPs.len] / [CapturedCPs.len+UnCapturedCPs.len] Command Posts")
		stat(CapturedCPs)

	if(statpanel("Inventory"))
		stat("<b>Left Click to Equip/Use")
		stat("$ Points:	[src.CashPoints]")
		stat(CashPointsLink)
		stat("<b>Items [src.contents.len]/[src.PackSize]")
		stat(src.contents)
		stat("<b>Left Click to Equip/Use")

	if(statpanel("Stats"))
		stat(TabGenericStats)
		if(src.ShowGenericStats)
			stat("Level:","[src.Level] -:- [src.Exp]/[(src.Level)*100] EXP")
			stat("$ Points:",src.CashPoints)
			stat(CashPointsLink)
			stat("Shots Fired:","[src.TotalShots]")
			stat("Body Shots:","[src.ShotsHit-src.HeadShots]")
			stat("Head Shots:","[src.HeadShots]")
			if(src.TotalShots)	stat("Accuracy:","[round((src.ShotsHit/src.TotalShots)*100)]%")
			else	stat("Accuracy:","No Shots Fired")
			stat("Career Kills:","[src.TotalKills]")
		stat(TabWeaponStats)
		if(src.ShowWeaponStats)
			if(!src.Weapon)
				stat("No Weapon","No Weapon Equipped...")
			else
				stat(src.Weapon)
				stat("Level:","[src.Weapon.Level] -:- [src.Weapon.Exp]/[(src.Weapon.Level)*100] EXP")
				stat("Fire Power:","[src.Weapon.FirePower]")
				stat("Fire Rate:","[src.Weapon.FireRate]")
				stat("Reload Time:","[src.Weapon.ReloadTime]")
				stat("Ammo:","[src.Weapon.Ammo]/[src.Weapon.MaxAmmo] [src.Weapon.AmmoTypeName]")
				stat("Proficiency:","[src.Weapon.Proficiency]%")
		stat(TabSpecStats)
		if(src.ShowSpecStats)
			stat("<b>Class:","[src.Class]")
			stat("<b>Sub Weapon:","[src.SubWeapon]")
			stat("<b>Skills:","")
			stat(src.Skills)

	if(statpanel("Controls"))
		stat("<b>Key","<b>Action")
		stat("WASD","Movement")
		stat("E","Interact")
		stat("F","FlashLight")
		stat("H","Help")
		stat("M","Map")
		stat("V","Knife")
		stat("R","Reload")
		stat("T","Throw Grenade")
		stat("Q","Class Skill 2")
		stat("Z","Class Skill 1")
		stat("Enter","Global Chat")
		stat("1-0","Voice Commands")
		stat("Left Mouse","Precision Shot")
		stat("Middle Mouse","Toggle Auto Fire")
		stat("","")
		stat("<b>Key","<b>Statement")
		stat("1","Roger That")
		stat("2","Negative")
		stat("3","Cover Me")
		stat("4","OK Lets Go")
		stat("5","Follow Me")
		stat("6","Hold This Position")
		stat("7","Team Fall Back")
		stat("8","Need Backup")
		stat("9","Stick Together Team")
		stat("0","Lock 'n Load")

	if(statpanel("Server"))
		var/hours=round(world.time/10/60/60)
		var/minutes=round(world.time/10/60-(60*hours))
		var/seconds=round(world.time/10-(60*minutes)-(60*hours*60))
		var/TOD="Dawn"
		if(DayPart==2)	TOD="Noon"
		if(DayPart==3)	TOD="Dusk"
		if(DayPart==4)	TOD="Night"
		stat("Host:","[world.host]")
		stat("Version:","[GameVersion]")
		stat("Players:","[Players.len] / [PlayerLimit]")
		stat("Usage:","[world.cpu]%")
		stat("Link:","[world.internet_address]:[world.port]")
		stat("Up Time:","[hours]:[minutes]:[seconds]")
		stat("----- --- ----- ---","----- --- -----")
		stat("Game Time:","[TOD] [Days]")
		if(DayPart>=3)	stat("Raiding:","[NightPoint]")
		else	stat("Raided:","[NightPoint]")
		stat("Zombies:","[Zombies.len] / [ZombieMax]")
		stat("Global Kills:","[FullNum(ZombiesKilled)]")