var/list/SubList=list()
mob/var/Subscriber=0

proc/TrimSpaces(var/Text2Trim)
	while(length(Text2Trim)>=1 && copytext(Text2Trim,1,2)==" ")
		Text2Trim=copytext(Text2Trim,2,0)
	while(length(Text2Trim)>=2 && copytext(Text2Trim,length(Text2Trim),0)==" ")
		Text2Trim=copytext(Text2Trim,1,length(Text2Trim))
	return Text2Trim

proc/Split(var/text2split,var/SplitBy=",")
	var/CurPos=1
	var/list/SplitList=list()
	while(findtext(text2split,SplitBy,CurPos,0))
		var/NextPos=findtext(text2split,SplitBy,CurPos,0)
		SplitList+=copytext(text2split,CurPos,NextPos)
		CurPos=NextPos+1
	if(CurPos<=length(text2split))	SplitList+=copytext(text2split,CurPos,0)
	return SplitList

mob/proc/NameGuard(/**/)
	var/list/ReservedNames=list("Falacy","FaIacy","Strai")
	for(var/mob/Player/M in world)	if(M.client && M!=src)	ReservedNames+=M.name
	if(!src.name)	src.name=src.key
	src.name=html_encode(copytext(src.name,1,16))
	if(length(src.name)>=1)	src.name="[uppertext(copytext(src.name,1,2))][copytext(src.name,2)]"
	src.name=AsciiCheck(src.name)
	if(!src.name)	src.name=src.key
	if(src.name in ReservedNames)
		src.name=src.key
		src<<"<font color=red>This Name is Reserved!"
	if(src.name!=src.key)	src.name="[src.name]@[src.key]"

mob/var/FontColor="Black"
mob/var/NameColor="Black"
mob/Sub/verb
	Change_Name()
		set category="Subscriber"
		var/NewName=html_encode(copytext(input("Input your New Name","Change Name",usr.name) as text,1,25))
		for(var/mob/Player/M in world)	if(M.name==NewName)
			usr<<"Name Already in Use...";return
		if(usr.name=="Falacy" || usr.name=="FaIacy")	usr.name="Retard"
		usr.name=NewName
		usr.NameGuard();usr.AddName();usr.AddClassIcon()
		if(src.Squad && src.Squad.Leader==src)
			src.Squad.name="[src]'s Squad"
			for(var/mob/M in src.Squad.Members)	M.AddSquad()
	Font_Color()
		set category="Subscriber"
		usr.FontColor=input("Select your Font Color:","Font Color",usr.FontColor) as color
	Name_Color()
		set category="Subscriber"
		usr.NameColor=input("Select your Name Color:","Name Color",usr.NameColor) as color

mob/verb/Subscribe()
	set category="Subscriber"
	if(!SubKeyCheck(usr.key))	usr<<link("http://www.angelfire.com/hero/straygames/Subscribe.html")
	else	usr.SubCheck()

mob/verb/SubscribeMenu()
	set hidden=1
	switch(alert("Stray Games Subscription","Subscribe","Subscribe Now","Check Sub","More Info"))
		if("More Info")	usr<<link("http://www.angelfire.com/hero/straygames/SubscriberInfo.html")
		if("Check Sub")	usr.SubCheck()
		if("Subscribe Now")	usr<<link("http://www.angelfire.com/hero/straygames/Subscribe.html")

proc/LoadSubs(var/Loop=1)
	var/http[]=world.Export("http://www.angelfire.com/hero/straygames/Subscribers.txt")
	if(!http)	//Site could not be contacted
		if(Loop)	spawn(600)	LoadSubs()
		return
	var/F=file2text(http["CONTENT"])
	if(copytext(F,1,2)!="B")	//Invalid site reached?
		if(Loop)	spawn(600)	LoadSubs()
		return
	SubList=list()
	var/counter=1
	while(findtext(F,CRGRTN,counter,0))
		var/SubLine=copytext(F,counter,findtext(F,CRGRTN,counter,0))
		var/list/SplitList=Split(SubLine,"/")
		for(var/x in SplitList)	SubList+=x
		counter=findtext(F,CRGRTN,counter,0)+1
	world<<"<b><font color=green>Server Info:</font> Subscriber List Successfully Loaded"
	ActivateNewSubs()
	if(Loop)	spawn(36000)	LoadSubs()

mob/proc/RemoveSub()
	src.Subscriber=0;src.verbs-=typesof(/mob/Sub/verb)

proc/ActivateNewSubs()
	for(var/mob/M in Players)
		if(M.Subscriber)		if(!SubKeyCheck(M.key))
			M.RemoveSub();world<<"[M]'s Subscription Expired =("
		else	if(SubKeyCheck(M.key))
			M.SubCheck();world<<"[M]'s Subscription is now Active =D"

proc/SubKeyCheck(var/Key2Check)
	var/CurrentDate=text2num(time2text(world.timeofday,"YYMMDD"))
	var/KeyLocation=SubList.Find(Key2Check,1,0)
	if(KeyLocation)
		var/ExpDate=SubList[KeyLocation+1]
		var/Converted=copytext(ExpDate,7,9)+copytext(ExpDate,1,3)+copytext(ExpDate,4,6)
		var/ExpDateNum=text2num(Converted)
		if(ExpDateNum-CurrentDate>0)	return 1

mob/proc/SubCheck()
	SubInfo()
	var/CurrentDate=text2num(time2text(world.timeofday,"YYMMDD"))
	var/KeyLocation=SubList.Find(src.key,1,0)
	if(KeyLocation)
		var/ExpDate=SubList[KeyLocation+1]
		var/Converted=copytext(ExpDate,7,9)+copytext(ExpDate,1,3)+copytext(ExpDate,4,6)
		var/ExpDateNum=text2num(Converted)
		if(ExpDateNum-CurrentDate>0)
			src.Subscriber=1;src.verbs+=typesof(/mob/Sub/verb)

mob/proc/SubInfo(/**/)
	src<<""
	var/CurrentDate=text2num(time2text(world.timeofday,"YYMMDD"))
	var/KeyLocation=SubList.Find(src.key,1,0)
	if(KeyLocation)
		var/ExpDate=SubList[KeyLocation+1]
		var/Converted=copytext(ExpDate,7,9)+copytext(ExpDate,1,3)+copytext(ExpDate,4,6)
		var/ExpDateNum=text2num(Converted)
		if(ExpDateNum-CurrentDate>0)
			src<<"You are Subscribed to Stray Games"
			src<<"Your Subscription Expires on: [ExpDate]"
			src<<"Current Date: [time2text(world.timeofday,"MM-DD-YY")]"
		else
			src<<"Your Subscription to Stray Games Expired on [ExpDate]"
			src<<"Current Date: [time2text(world.timeofday,"MM-DD-YY")]"
			src<<{"<a href="http://www.angelfire.com/hero/straygames/SubscriberInfo.html">Click here to Renew your Subscription!</a>"}
	else
		src<<"You are not Subscribed to Stray Games"
		src<<{"<a href="http://www.angelfire.com/hero/straygames/SubscriberInfo.html">Click here to Subscribe today!</a>"}
	src<<""


mob/verb/View_Subscribers()
	var/text="<center><body bgcolor=gray><table bgcolor=gray border=1 bordercolor=black>"
	text+="<tr><td colspan=2><center><b>Subscriber List</b><br>[SubList.len/2] Total Subscribers"
	text+="<tr><td>Current Date<td>[time2text(world.timeofday,"MM-DD-YY")]"
	text+="<tr><td><b>Key<td><center><b>Expires<tr>"
	var/KeyLink="";var/OnName=0
	for(var/t in SubList)
		OnName=!OnName
		if(OnName)	KeyLink="[t]"
		else	text+="<td>[KeyLink]	<td>[t]<tr>"
	usr<<browse("[text]","window=ViewSubscribers")

proc/AsciiCheck(var/t as text)
	var/counter=0
	while(counter<=length(t)-1)
		counter+=1
		var/AscVal=text2ascii(t,counter)
		if(AscVal>=48 && AscVal<=57)	continue//checks if its a number 0-9
		if(AscVal>=65 && AscVal<=90)	continue//checks if its a letter A-Z
		if(AscVal>=97 && AscVal<=122)	continue//checks if its a letter a-z
		if(AscVal==32)	continue//checks if its a space
		usr<<"Characters A-Z, 0-9, and Spaces Only!"
		return null
	return t